
require 'net/imap'

class At_email::Account::Imap < Net::IMAP
  attr_accessor :debug
end

class At_email::Account::ImapConnection

  attr_reader :imap

  METADATA_ATTRIBUTES = [ 'ENVELOPE', 'FLAGS' ].freeze
  REQUESTED_ATTRIBUTES = [ 'INTERNALDATE', 'RFC822', 'RFC822.SIZE' ].freeze

  def initialize()
    $logger.info 'Connecting to IMAP server - Host: ' + $config[:server] + ' - Port: ' + $config[:port].to_s
    connect_config = {port: $config[:port], ssl: $config[:ssl]}
    @imap = At_email::Account::Imap.new($config[:server], connect_config)
  end

  def login
    $logger.info 'Logging into IMAP server - Username: ' + $config[:username]
    @imap.login($config[:username], $config[:password])
  end

  def disconnect
    $logger.debug 'Logging out from IMAP server'
    @imap.logout
    @imap.disconnect
  end

end
