
class At_email::Core::Default

  CLASS_DISPLAY_NAME = 'atEmail - Default Class'

  attr_accessor :properties

  def initialize()
    @properties = {}
    @properties['State'] = 'New'
    @properties['ID'] = At_email::Formatting.new.get_random_id(5)
    @properties['Display Name'] = CLASS_DISPLAY_NAME
    @properties['Log Prefix'] = @properties['Display Name'] + ': ' + @properties['ID']
    @properties['State'] = 'Initialized'
  end

  def get(property)
    if !@properties[property]
      log_event event_tag='ERROR', 'Cannot get property: ' + property + "\n" + __LINE__ + "\n" + (pp caller())
      return false
    end
    return @properties[property]
  end

  def get_formatted(property)
    value = get(property)
    output = property + ': ' + value.to_s
    return output
  end

  def get_state()
    return get('State')
  end

  def set_state(value)
    set('State', value)
  end

  ### start of private methods
  private

  def log_event(event_tag='', event_data)
    log_prefix = get['Log Prefix']
    log_string = log_prefix + ' - ' + event_data
    $logger.event(event_tag, event_data)
  end

  def set(property, value)
    if @properties[property]
      @properties[property] = value
    end
  end

  def create_new_property(property, value)
    if @properties[property]
      return false
    else
      @properties[property] = value
    end
  end

end
